## mmseqs2 9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
project(MMseqs CXX C)
message("-- Source Directory: ${CMAKE_CURRENT_SOURCE_DIR}")
message("-- Project Directory: ${PROJECT_SOURCE_DIR}")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(FRAMEWORK_ONLY 0 CACHE BOOL "Framework Mode")
set(HAVE_SANITIZER 0 CACHE BOOL "Have Sanitizers")
set(VERSION_OVERRIDE "" CACHE STRING "Override version string in help and usage messages")

#Sanitizers
if (${HAVE_SANITIZER})
    include(FindUBSan)
    include(FindASan)
    include(FindMSan)
    include(FindTSan)
endif ()

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif (NOT CMAKE_BUILD_TYPE)

# find compiler
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    # using Clang
    message("-- Compiler is clang(++)")
    set(CMAKE_COMPILER_IS_CLANG 1)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    # using GCC
    message("-- Compiler is GNU ")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8.0")
        message(FATAL_ERROR "Insufficient gcc version")
    endif ()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    # using Intel C++
    message("-- Compiler is icc(++)")
    set(CMAKE_COMPILER_IS_ICC 1)
endif ()

# set flags
set(MMSEQS_CXX_FLAGS "-std=c++0x")
if (NOT ${HAVE_NEON})
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -m64")
endif ()

# Compiler-specific features
if (CMAKE_COMPILER_IS_CLANG)
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11")
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -stdlib=libc++")
endif ()

# Apple specific features
if (APPLE)
    # macOS SDK started using _Atomic (in ucred.h) which g++ does not support
    # __APPLE_API_STRICT_CONFORMANCE makes sysctl.h not include apis like ucred.h
    # See: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=89864
    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -D__APPLE_API_STRICT_CONFORMANCE")
endif ()

# zstd
SET(ZSTD_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/lib/zstd")
SET(CMAKE_INSTALL_LIBDIR bin)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/lib/zstd/build/cmake/CMakeModules")
OPTION(ZSTD_LEGACY_SUPPORT "LEGACY SUPPORT" OFF)
OPTION(ZSTD_BUILD_STATIC "BUILD STATIC LIBRARIES" ON)
OPTION(ZSTD_BUILD_SHARED "BUILD SHARED LIBRARIES" OFF)
OPTION(ZSTD_MULTITHREAD_SUPPORT "MULTITHREADING SUPPORT" OFF)
OPTION(ZSTD_BUILD_PROGRAMS "BUILD PROGRAMS" OFF)
OPTION(ZSTD_BUILD_CONTRIB "BUILD CONTRIB" OFF)
OPTION(ZSTD_BUILD_TESTS "BUILD TESTS" OFF)
add_subdirectory(lib/zstd/build/cmake/lib EXCLUDE_FROM_ALL)

# tinyexpr
OPTION(TE_NAT_LOG "Define the log function as natural logarithm." ON)
include_directories(lib/tinyexpr)
add_subdirectory(lib/tinyexpr EXCLUDE_FROM_ALL)

include_directories(lib)
include_directories(lib/kseq)
include_directories(lib/simd)
include_directories(lib/gzstream)
include_directories(lib/alp)
include_directories(lib/cacode)
include_directories(lib/ksw2)
add_subdirectory(lib/cacode)
add_subdirectory(lib/alp)
add_subdirectory(lib/ksw2)
add_subdirectory(data)
add_subdirectory(src)
if (NOT FRAMEWORK_ONLY)
    add_subdirectory(util)
endif ()

=== data/CMakeLists.txt ===
include(MMseqsResourceCompiler)

set(COMPILED_RESOURCES
        easysearch.sh
        easycluster.sh
        easytaxonomy.sh
        blastp.sh
        blastpgp.sh
        map.sh
        rbh.sh
        linclust.sh
        clustering.sh
        cascaded_clustering.sh
        update_clustering.sh
        searchtargetprofile.sh
        createindex.sh
        createtaxdb.sh
        translated_search.sh
        taxonomy.sh
        multihitdb.sh
        multihitsearch.sh
        summarizeresultsbyset.sh
        enrich.sh
        blastn.sh
        VTML80.out
        nucleotide.out
        blosum62.out
        PAM30.out
        CovSeqidQscPercMinDiag.out
        CovSeqidQscPercMinDiagTargetCov.out
        ExpOpt3_8_polished.cs32.lib
        Library255_may17.lib
        libPure_blosum62_255.lib
        libPure_blosum62_32.lib
        libPolished_8.lib
        searchslicedtargetprofile.sh
        cs219.lib
        linsearch.sh
        )

set(GENERATED_OUTPUT_HEADERS "")
FOREACH(INPUT_FILE ${COMPILED_RESOURCES})
    compile_resource(${INPUT_FILE} OUTPUT_FILE)
    list(APPEND GENERATED_OUTPUT_HEADERS "${OUTPUT_FILE}")
ENDFOREACH()

add_custom_target(generated ALL DEPENDS ${GENERATED_OUTPUT_HEADERS})

=== src/CMakeLists.txt ===
set(HAVE_MPI 0 CACHE BOOL "Have MPI")
set(HAVE_AVX2 0 CACHE BOOL "Have AVX2")
set(HAVE_SSE4_1 0 CACHE BOOL "Have SSE4.1")
set(HAVE_NEON 0 CACHE BOOL "Have NEON")
set(HAVE_TESTS 1 CACHE BOOL "Have Tests")
set(HAVE_SHELLCHECK 1 CACHE BOOL "Have ShellCheck")
set(HAVE_GPROF 0 CACHE BOOL "Have GPROF Profiler")
set(ENABLE_WERROR 0 CACHE BOOL "Enable Warnings as Errors")

include(AppendTargetProperty)

add_subdirectory(alignment)
add_subdirectory(clustering)
add_subdirectory(commons)
add_subdirectory(linclust)
add_subdirectory(multihit)
add_subdirectory(prefiltering)
add_subdirectory(taxonomy)
add_subdirectory(util)
add_subdirectory(workflow)

add_library(mmseqs-framework
        $<TARGET_OBJECTS:alp>
        $<TARGET_OBJECTS:ksw2>
        $<TARGET_OBJECTS:cacode>
        ${alignment_header_files}
        ${alignment_source_files}
        ${clustering_header_files}
        ${clustering_source_files}
        ${commons_header_files}
        ${commons_source_files}
        ${prefiltering_header_files}
        ${prefiltering_source_files}
        ${multihit_header_files}
        ${multihit_source_files}
        ${taxonomy_header_files}
        ${taxonomy_source_files}
        ${linclust_source_files}
        ${util_header_files}
        ${util_source_files}
        ${workflow_source_files})

target_include_directories(mmseqs-framework PUBLIC ${CMAKE_BINARY_DIR}/generated)
target_include_directories(mmseqs-framework PUBLIC ${PROJECT_BINARY_DIR}/generated)
target_include_directories(mmseqs-framework PUBLIC alignment)
target_include_directories(mmseqs-framework PUBLIC clustering)
target_include_directories(mmseqs-framework PUBLIC commons)
target_include_directories(mmseqs-framework PUBLIC multihit)
target_include_directories(mmseqs-framework PUBLIC prefiltering)
target_include_directories(mmseqs-framework PUBLIC linclust)
target_include_directories(mmseqs-framework PUBLIC taxonomy)
target_include_directories(mmseqs-framework PUBLIC util)
target_include_directories(mmseqs-framework PUBLIC .)

add_dependencies(mmseqs-framework generated)

if (CMAKE_BUILD_TYPE MATCHES RELEASE OR CMAKE_BUILD_TYPE MATCHES RELWITHDEBINFO)
    if (CMAKE_COMPILER_IS_ICC)
        append_target_property(mmseqs-framework COMPILE_FLAGS -ipo -no-prec-div -xHost)
        append_target_property(mmseqs-framework LINK_FLAGS -ipo -no-prec-div -xHost)
    else ()
        append_target_property(mmseqs-framework COMPILE_FLAGS -ffast-math -ftree-vectorize -fno-strict-aliasing)
        append_target_property(mmseqs-framework LINK_FLAGS -ffast-math -ftree-vectorize -fno-strict-aliasing)
    endif ()
endif ()

append_target_property(mmseqs-framework COMPILE_FLAGS ${MMSEQS_CXX_FLAGS} -fno-exceptions -pedantic -Wall -Wextra -Wdisabled-optimization)
append_target_property(mmseqs-framework LINK_FLAGS ${MMSEQS_CXX_FLAGS} -fno-exceptions -pedantic -Wall -Wextra -Wdisabled-optimization)

if (${ENABLE_WERROR})
    append_target_property(mmseqs-framework COMPILE_FLAGS -Werror)
    append_target_property(mmseqs-framework LINK_FLAGS -Werror)
endif()

if (CYGWIN OR ${HAVE_NEON})
    target_compile_definitions(mmseqs-framework PUBLIC -D_GNU_SOURCE=1)
endif ()

# needed for concat.h
include(CheckCXXSourceRuns)
check_cxx_source_runs("
        #include <stdlib.h>
        #include <fcntl.h>
        #include <stdio.h>

        int main() {
          FILE* tmpf = tmpfile();
          int input_desc = fileno(tmpf);
          int test = posix_fadvise(input_desc, 0, 0, POSIX_FADV_SEQUENTIAL);
          fclose(tmpf);
          return 0;
        }"
        HAVE_POSIX_FADVISE)
if (HAVE_POSIX_FADVISE)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_POSIX_FADVISE=1)
endif ()

check_cxx_source_runs("
        #include <stdlib.h>
        #include <fcntl.h>
        #include <stdio.h>
        #include <sys/mman.h>

        int main() {
          FILE* tmpf = tmpfile();
          void *tmp = mmap(NULL, 32, PROT_READ, MAP_SHARED, fileno(tmpf), 0);
          int test = posix_madvise(tmp, 32, POSIX_MADV_SEQUENTIAL);
          fclose(tmpf);
          return 0;
        }"
        HAVE_POSIX_MADVISE)
if (HAVE_POSIX_MADVISE)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_POSIX_MADVISE=1)
endif ()

#SSE
if (${HAVE_AVX2})
    target_compile_definitions(mmseqs-framework PUBLIC -DAVX2=1)
    append_target_property(mmseqs-framework COMPILE_FLAGS -mavx2 -Wa,-q)
    append_target_property(mmseqs-framework LINK_FLAGS -mavx2 -Wa,-q)
elseif (${HAVE_SSE4_1})
    target_compile_definitions(mmseqs-framework PUBLIC -DSSE=1)
    append_target_property(mmseqs-framework COMPILE_FLAGS -msse4.1)
    append_target_property(mmseqs-framework LINK_FLAGS -msse4.1)
elseif (${HAVE_NEON})
    target_compile_definitions(mmseqs-framework PUBLIC -DSSE=1 -DNEON=1)
else ()
    include(CheckSSEFeatures)
    append_target_property(mmseqs-framework COMPILE_FLAGS ${SSE_FLAGS})
    append_target_property(mmseqs-framework LINK_FLAGS ${SSE_FLAGS})
    if (${HAVE_AVX2_EXTENSIONS})
        target_compile_definitions(mmseqs-framework PUBLIC -DAVX2=1)
        # debugging
        #   list(APPEND MMSEQS_DEFINITIONS -DSSE=1)
    else ()
        if (${HAVE_SSE4_1_EXTENSIONS})
            target_compile_definitions(mmseqs-framework PUBLIC -DSSE=1)
        else ()
            message(FATAL_ERROR "At least SSE4.2 is needed to compile!")
        endif (${HAVE_SSE4_1_EXTENSIONS})
    endif (${HAVE_AVX2_EXTENSIONS})
endif ()

# tinyexpr
target_link_libraries(mmseqs-framework tinyexpr)

find_package(ZLIB QUIET)
if (ZLIB_FOUND)
    message("-- Found ZLIB")
    set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
    set(OLD_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
    set(OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_FLAGS -lz)
    set(CMAKE_REQUIRED_INCLUDES ${ZLIB_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${ZLIB_LIBRARIES})
    check_cxx_source_runs("
        #include <zlib.h>
        int main() { gzFile file; return 0; }"
        HAVE_ZLIB_CHECK)
    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
    set(CMAKE_REQUIRED_INCLUDES ${OLD_CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
    if(HAVE_ZLIB_CHECK)
        message("-- ZLIB works")
        target_include_directories(mmseqs-framework PUBLIC ${ZLIB_INCLUDE_DIRS})
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_ZLIB=1)
        target_link_libraries(mmseqs-framework ${ZLIB_LIBRARIES})
    else ()
        message("-- ZLIB does not work")
    endif()
else ()
    message("-- Could not find ZLIB")
endif ()

find_package(BZip2 QUIET)
if (BZIP2_FOUND)
    message("-- Found BZLIB")
    set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
    set(OLD_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
    set(OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_FLAGS -lbz2)
    set(CMAKE_REQUIRED_INCLUDES ${BZIP_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${BZIP2_LIBRARIES})
    check_cxx_source_runs("
        #include <bzlib.h>
        int main() { bz_stream stream; return 0; }"
        HAVE_BZLIB_CHECK)
    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
    set(CMAKE_REQUIRED_INCLUDES ${OLD_CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
    if(HAVE_BZLIB_CHECK)
        message("-- BZLIB works")
        target_include_directories(mmseqs-framework PUBLIC ${BZIP_INCLUDE_DIRS})
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_BZLIB=1)
        target_link_libraries(mmseqs-framework ${BZIP2_LIBRARIES})
    else ()
        message("-- BZLIB does not work")
    endif()
else ()
    message("-- Could not find BZLIB")
endif ()

# MPI
if (${HAVE_MPI})
    find_package(MPI REQUIRED)
    if (MPI_FOUND)
        message("-- Found MPI")
        target_include_directories(mmseqs-framework PUBLIC ${MPI_INCLUDE_PATH})
        #Hack (OMPI_SKIP_MPICXX=1): https://github.com/open-mpi/ompi/issues/5157#issuecomment-388495496
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_MPI=1 -DOMPI_SKIP_MPICXX=1)
        target_link_libraries(mmseqs-framework ${MPI_LIBRARIES})
        append_target_property(mmseqs-framework COMPILE_FLAGS ${MPI_COMPILE_FLAGS})
        append_target_property(mmseqs-framework LINK_FLAGS ${MPI_LINK_FLAGS})
    endif ()
endif ()

# openmp integration
find_package(OpenMP)
if (OPENMP_FOUND)
    message("-- Found OpenMP")
    target_compile_definitions(mmseqs-framework PUBLIC -DOPENMP=1)
    target_link_libraries(mmseqs-framework ${OpenMP_CXX_LIBRARIES})
    append_target_property(mmseqs-framework COMPILE_FLAGS ${OpenMP_CXX_FLAGS})
    append_target_property(mmseqs-framework LINK_FLAGS ${OpenMP_CXX_FLAGS})
endif ()

if (${HAVE_GPROF})
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag(-pg GPROF_FOUND)
    if (GPROF_FOUND)
        append_target_property(mmseqs-framework COMPILE_FLAGS -pg)
        append_target_property(mmseqs-framework LINK_FLAGS -pg)
    else ()
        message(FATAL_ERROR "-- Could not find GPROF")
    endif ()
endif ()

if (NOT FRAMEWORK_ONLY)
    include(MMseqsSetupDerivedTarget)
    add_subdirectory(version)
    set(mmseqs_source_files
            CommandDeclarations.h
            mmseqs.cpp
            )

    add_executable(mmseqs ${mmseqs_source_files})
    mmseqs_setup_derived_target(mmseqs)
    target_link_libraries(mmseqs version)
    install(TARGETS mmseqs DESTINATION bin)

    if (HAVE_TESTS)
        add_subdirectory(test)
    endif ()
endif ()

=== lib/alp/CMakeLists.txt ===
add_library(alp OBJECT
        sls_basic.hpp
        njn_dynprogprob.cpp
        njn_random.cpp
        sls_pvalues.hpp
        njn_random.hpp
        njn_integer.hpp
        njn_doubletype.hpp
        njn_dynprogprob.hpp
        njn_dynprogproblim.hpp
        sls_alp_sim.hpp
        njn_dynprogprobproto.cpp
        njn_localmaxstatutil.hpp
        njn_localmaxstat.cpp
        njn_localmaxstat.hpp
        njn_matrix.hpp
        njn_localmaxstatmatrix.cpp
        sls_alp_regression.hpp
        sls_alp_sim.cpp
        sls_pvalues.cpp
        njn_root.hpp
        njn_dynprogproblim.cpp
        sls_alignment_evaluer.cpp
        njn_localmaxstatmatrix.hpp
        sls_alp_regression.cpp
        njn_dynprogprobproto.hpp
        sls_alp.cpp
        njn_approx.hpp
        njn_memutil.hpp
        njn_localmaxstatutil.cpp
        njn_function.hpp
        njn_ioutil.hpp
        sls_basic.cpp
        njn_uniform.hpp
        sls_alignment_evaluer.hpp
        njn_vector.hpp
        sls_alp_data.cpp
        sls_alp_data.hpp
        njn_ioutil.cpp
        sls_alp.hpp
        sls_normal_distr_array.hpp
        )
set_target_properties(alp PROPERTIES COMPILE_FLAGS ${MMSEQS_CXX_FLAGS} -w LINK_FLAGS ${MMSEQS_CXX_FLAGS} -w)

=== src/alignment/CMakeLists.txt ===
set(alignment_header_files
        alignment/Alignment.h
        alignment/CompressedA3M.h
        alignment/EvalueComputation.h
        alignment/Matcher.h
        alignment/MsaFilter.h
        alignment/MultipleAlignment.h
        alignment/PSSMCalculator.h
        alignment/StripedSmithWaterman.h
        alignment/BandedNucleotideAligner.h
        alignment/DistanceCalculator.h
        PARENT_SCOPE
        )

set(alignment_source_files
        alignment/Alignment.cpp
        alignment/CompressedA3M.cpp
        alignment/Main.cpp
        alignment/Matcher.cpp
        alignment/MsaFilter.cpp
        alignment/MultipleAlignment.cpp
        alignment/PSSMCalculator.cpp
        alignment/StripedSmithWaterman.cpp
        alignment/BandedNucleotideAligner.cpp
        alignment/rescorediagonal.cpp
        PARENT_SCOPE
        )

=== src/clustering/CMakeLists.txt ===
set(clustering_header_files
        clustering/AlignmentSymmetry.h
        clustering/Clustering.h
        clustering/ClusteringAlgorithms.h
        clustering/Main.cpp
        clustering/SetElement.h
        PARENT_SCOPE
        )

set(clustering_source_files
        clustering/AlignmentSymmetry.cpp
        clustering/Clustering.cpp
        clustering/ClusteringAlgorithms.cpp
        clustering/Main.cpp
        PARENT_SCOPE
        )

=== src/commons/CMakeLists.txt ===
set(commons_header_files
        commons/A3MReader.h
        commons/AminoAcidLookupTables.h
        commons/BacktraceTranslator.h
        commons/Command.h
        commons/CommandCaller.h
        commons/Concat.h
        commons/CpuInfo.h
        commons/DBConcat.h
        commons/DBReader.h
        commons/DBWriter.h
        commons/Debug.h
        commons/Domain.h
        commons/ExpressionParser.h
        commons/FileUtil.h
        commons/HeaderSummarizer.h
        commons/IndexReader.h
        commons/itoa.h
        commons/MathUtil.h
        commons/MemoryMapped.h
        commons/MMseqsMPI.h
        commons/NucleotideMatrix.h
        commons/Orf.h
        commons/ProfileStates.h
        commons/LibraryReader.h
        commons/Parameters.h
        commons/PatternCompiler.h
        commons/ScoreMatrix.h
        commons/Sequence.h
        commons/SubstitutionMatrix.h
        commons/SubstitutionMatrixProfileStates.h
        commons/tantan.h
        commons/TranslateNucl.h
        commons/Timer.h
        commons/UniprotKB.h
        commons/Util.h
        PARENT_SCOPE
        )

set(commons_source_files
        commons/A3MReader.cpp
        commons/Application.cpp
        commons/BaseMatrix.cpp
        commons/Command.cpp
        commons/CommandCaller.cpp
        commons/DBConcat.cpp
        commons/DBReader.cpp
        commons/DBWriter.cpp
        commons/Debug.cpp
        commons/ExpressionParser.cpp
        commons/FileUtil.cpp
        commons/HeaderSummarizer.cpp
        commons/KSeqWrapper.cpp
        commons/MemoryMapped.cpp
        commons/MMseqsMPI.cpp
        commons/NucleotideMatrix.cpp
        commons/Orf.cpp
        commons/Parameters.cpp
        commons/ProfileStates.cpp
        commons/LibraryReader.cpp
        commons/Sequence.cpp
        commons/SubstitutionMatrix.cpp
        commons/tantan.cpp
        commons/UniprotKB.cpp
        commons/Util.cpp
        PARENT_SCOPE
        )

=== src/taxonomy/CMakeLists.txt ===
set(taxonomy_header_files
        taxonomy/NcbiTaxonomy.h
        PARENT_SCOPE
        )


set(taxonomy_source_files
        taxonomy/lca.cpp
        taxonomy/addtaxonomy.cpp
        taxonomy/NcbiTaxonomy.cpp
        taxonomy/filtertaxdb.cpp
        taxonomy/createtaxdb.cpp
        taxonomy/taxonomyreport.cpp
        PARENT_SCOPE
        )

=== src/test/CMakeLists.txt ===
include(MMseqsSetupTest)

set(TESTS
        #TestAdjustedKmerIterator.cpp
        TestAlignment.cpp
        TestAlignmentPerformance.cpp
        TestAlignmentTraceback.cpp
        TestAlp.cpp
        TestBacktraceTranslator.cpp
        TestCompositionBias.cpp
        TestCounting.cpp
        TestDBReader.cpp
        TestDBReaderIndexSerialization.cpp
        TestDiagonalScoring.cpp
        TestDiagonalScoringPerformance.cpp
        TestIndexTable.cpp
        TestKmerGenerator.cpp
        TestKmerNucl.cpp
        TestKmerScore.cpp
        TestKwayMerge.cpp
        TestMultipleAlignment.cpp
        TestProfileAlignment.cpp
        TestPSSM.cpp
        TestPSSMPrune.cpp
        TestDBReaderZstd.cpp
        TestReduceMatrix.cpp
        TestScoreMatrixSerialization.cpp
        TestSequenceIndex.cpp
        TestTanTan.cpp
        TestTaxonomy.cpp
        TestTranslate.cpp
        TestTinyExpr.cpp
        TestProfileStates.cpp
        TestUtil.cpp
        TestKsw2.cpp
        TestBestAlphabet.cpp
        )


FOREACH (TEST ${TESTS})
    mmseqs_setup_test(${TEST})
ENDFOREACH ()

=== src/util/CMakeLists.txt ===
set(util_source_files
        util/alignall.cpp
        util/alignbykmer.cpp
        util/apply.cpp
        util/clusthash.cpp
        util/compress.cpp
        util/convert2fasta.cpp
        util/convertalignments.cpp
        util/convertca3m.cpp
        util/convertkb.cpp
        util/convertmsa.cpp
        util/convertprofiledb.cpp
        util/createdb.cpp
        util/dbtype.cpp
        util/indexdb.cpp
        util/offsetalignment.cpp
        util/createseqfiledb.cpp
        util/createsubdb.cpp
        util/view.cpp
        util/createtsv.cpp
        util/diffseqdbs.cpp
        util/expandaln.cpp
        util/extractalignedregion.cpp
        util/extractdomains.cpp
        util/extractorfs.cpp
        util/orftocontig.cpp
        util/touchdb.cpp
        util/filterdb.cpp
        util/gff2db.cpp
        util/masksequence.cpp
        util/maskbygff.cpp
        util/mergeclusters.cpp
        util/mergeresultsbyset.cpp
        util/mergedbs.cpp
        util/msa2profile.cpp
        util/mvdb.cpp
        util/countkmer.cpp
        util/prefixid.cpp
        util/profile2cs.cpp
        util/profile2pssm.cpp
        util/result2flat.cpp
        util/result2msa.cpp
        util/result2rbh.cpp
        util/result2profile.cpp
        util/result2pp.cpp
        util/result2repseq.cpp
        util/result2stats.cpp
        util/reverseseq.cpp
        util/rmdb.cpp
        util/shellcompletion.cpp
        util/extractframes.cpp
        util/sortresult.cpp
        util/splitdb.cpp
        util/splitsequence.cpp
        util/subtractdbs.cpp
        util/summarizealis.cpp
        util/summarizeheaders.cpp
        util/summarizeresult.cpp
        util/summarizetabs.cpp
        util/swapresults.cpp
        util/transitivealign.cpp
        util/translatenucs.cpp
        util/translateaa.cpp
        util/tsv2db.cpp
        util/proteinaln2nucl.cpp
        util/versionstring.cpp
        util/diskspaceavail.cpp
        PARENT_SCOPE
        )

=== src/workflow/CMakeLists.txt ===
set(workflow_source_files
        workflow/Cluster.cpp
        workflow/ClusterUpdate.cpp
        workflow/Linclust.cpp
        workflow/EasySearch.cpp
        workflow/EasyCluster.cpp
        workflow/EasyLinclust.cpp
        workflow/Enrich.cpp
        workflow/Linsearch.cpp
        workflow/Map.cpp
        workflow/Rbh.cpp
        workflow/Search.cpp
        workflow/Taxonomy.cpp
        workflow/EasyTaxonomy.cpp
        workflow/CreateIndex.cpp
        PARENT_SCOPE
        )

## mmseqs2 9-d36de%2Bds

=== debian/changelog ===
mmseqs2 (9-d36de+ds-4) unstable; urgency=medium

  * Team upload.

  [ Shayan Doust ]
  * Fix some pathing for different archs
  * Exclude some archs

 -- Andrius Merkys <merkys@debian.org>  Tue, 22 Oct 2019 01:02:46 -0400

mmseqs2 (9-d36de+ds-3) unstable; urgency=medium

  * Team upload.

  [ Steffen Moeller ]
  * d/u/metadata: yamllint

  [ Andreas Tille ]
  * Fix spelling

 -- Andrius Merkys <merkys@debian.org>  Fri, 18 Oct 2019 00:44:22 -0400

mmseqs2 (9-d36de+ds-2) unstable; urgency=medium

  * Fixed changelog
  * Patch to fix the matrix serialization test
  * Forgot to deallocate within serialization patch
  * Fix test_bestalphabet binary. Now works. This is used within autopkgtest
  * Patch to fix test_alignmentperformance I have excluded this as it takes a
    *very* long time to perform and probably isn't worth it. Probably should be
    used alongside a profiler
  * Patch test_dbreader and include this in the unit test
  * Patch dbreaderserialization test and include in unit test
  * Patch to fix test_dbreaderzstd and include it in the unit test
  * Patch to fix test_indextable
  * This package is only 64 bit, set it as that
  * Append to copyright more entries that were missed out
  * Detect and write more copyright entries using decopy
  * Add more entries to the copyright file
  * Delete some unnecessary lib files and outputs These are used during build
    and serve no purpose to the end users
  * libbz2-dev as a new dependency as mmseqs2 accepts *.bz inputs
  * Copyright edit and changelog append
  * Forgot to set environmental variable

 -- Shayan Doust <hello@shayandoust.me>  Thu, 25 Jul 2019 03:38:36 +0100

mmseqs2 (9-d36de+ds-1) unstable; urgency=medium

  * Initial release (Closes: #932369)

 -- Shayan Doust <hello@shayandoust.me>  Mon, 15 Jul 2019 13:45:03 +0100

## mmseqs2 9-d36de+ds

=== debian/control ===
Source: mmseqs2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               cmake,
               libgzstream-dev,
               libzstd-dev,
               zlib1g-dev,
               libbz2-dev
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/med-team/mmseqs2
Vcs-Git: https://salsa.debian.org/med-team/mmseqs2.git
Homepage: https://github.com/soedinglab/MMseqs2

Package: mmseqs2
Architecture: amd64 kfreebsd-amd64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ultra fast and sensitive protein search and clustering
 MMseqs2 (Many-against-Many sequence searching) is a software suite to
 search and cluster huge proteins/nucleotide sequence sets. MMseqs2 is
 open source GPL-licensed software implemented in C++ for Linux, MacOS,
 and (as beta version, via cygwin) Windows. The software is designed to
 run on multiple cores and servers and exhibits very good scalability.
 MMseqs2 can run 10000 times faster than BLAST. At 100 times its speed it
 achieves almost the same sensitivity. It can perform profile searches
 with the same sensitivity as PSI-BLAST at over 400 times its speed.

Package: mmseqs2-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: mmseqs2
Description: optional resources for the mmseqs2 package
 MMseqs2 (Many-against-Many sequence searching) is a software suite to
 search and cluster huge proteins/nucleotide sequence sets. MMseqs2 is
 open source GPL-licensed software implemented in C++ for Linux, MacOS,
 and (as beta version, via cygwim) Windows. The software is designed to
 run on multiple cores and servers and exhibits very good scalability.
 MMseqs2 can run 10000 times faster than BLAST. At 100 times its speed it
 achieves almost the same sensitivity. It can perform profile searches
 with the same sensitivity as PSI-BLAST at over 400 times its speed.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_install:
	dh_install
	mkdir -p debian/mmseqs2/usr/lib/mmseqs2/test
	cp src/test/*.index debian/mmseqs2/usr/lib/mmseqs2/test
	cp src/test/dataGap debian/mmseqs2/usr/lib/mmseqs2/test
	cp src/test/dataLinear debian/mmseqs2/usr/lib/mmseqs2/test
	cp -r obj-$(DEB_HOST_MULTIARCH)/src/test debian/mmseqs2/usr/lib/mmseqs2

	# We also remove unneeded files & folders like CMake
	rm -r debian/mmseqs2/usr/lib/mmseqs2/test/CMakeFiles \
		debian/mmseqs2/usr/lib/mmseqs2/test/*.cmake \
		debian/mmseqs2/usr/lib/mmseqs2/test/Makefile \
		debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/*.lib \
		debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/CovSeqidQscPercMinDiag.out \
		debian/mmseqs2-examples/usr/share/doc/mmseqs2/example-data/CovSeqidQscPercMinDiagTargetCov.out || true

## mmseqs2 10

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 set(FRAMEWORK_ONLY 0 CACHE BOOL "Framework Mode")
 set(HAVE_SANITIZER 0 CACHE BOOL "Have Sanitizers")
+set(INSTALL_UTIL 1 CACHE BOOL "Install util scripts")
 set(VERSION_OVERRIDE "" CACHE STRING "Override version string in help and usage messages")
 
 #Sanitizers
@@ -21,7 +22,7 @@
 endif (NOT CMAKE_BUILD_TYPE)
 
 # find compiler
-if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
     # using Clang
     message("-- Compiler is clang(++)")
     set(CMAKE_COMPILER_IS_CLANG 1)
@@ -58,26 +59,31 @@
     set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -D__APPLE_API_STRICT_CONFORMANCE")
 endif ()
 
+if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
+    set(MMSEQS_CXX_FLAGS "${MMSEQS_CXX_FLAGS} -D_WITH_GETLINE")
+endif()
+
 # zstd
-SET(ZSTD_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/lib/zstd")
-SET(CMAKE_INSTALL_LIBDIR bin)
+# We use ZSTD_findDecompressedSize which is only available with ZSTD_STATIC_LINKING_ONLY
+# Thus we cannot use a system provided libzstd
+set(ZSTD_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/lib/zstd")
+set(CMAKE_INSTALL_LIBDIR bin)
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/lib/zstd/build/cmake/CMakeModules")
-OPTION(ZSTD_LEGACY_SUPPORT "LEGACY SUPPORT" OFF)
-OPTION(ZSTD_BUILD_STATIC "BUILD STATIC LIBRARIES" ON)
-OPTION(ZSTD_BUILD_SHARED "BUILD SHARED LIBRARIES" OFF)
-OPTION(ZSTD_MULTITHREAD_SUPPORT "MULTITHREADING SUPPORT" OFF)
-OPTION(ZSTD_BUILD_PROGRAMS "BUILD PROGRAMS" OFF)
-OPTION(ZSTD_BUILD_CONTRIB "BUILD CONTRIB" OFF)
-OPTION(ZSTD_BUILD_TESTS "BUILD TESTS" OFF)
+option(ZSTD_LEGACY_SUPPORT "LEGACY SUPPORT" OFF)
+option(ZSTD_BUILD_STATIC "BUILD STATIC LIBRARIES" ON)
+option(ZSTD_BUILD_SHARED "BUILD SHARED LIBRARIES" OFF)
+option(ZSTD_MULTITHREAD_SUPPORT "MULTITHREADING SUPPORT" OFF)
+option(ZSTD_BUILD_PROGRAMS "BUILD PROGRAMS" OFF)
+option(ZSTD_BUILD_CONTRIB "BUILD CONTRIB" OFF)
+option(ZSTD_BUILD_TESTS "BUILD TESTS" OFF)
+include_directories(lib/zstd/lib)
 add_subdirectory(lib/zstd/build/cmake/lib EXCLUDE_FROM_ALL)
 
 # tinyexpr
-OPTION(TE_NAT_LOG "Define the log function as natural logarithm." ON)
 include_directories(lib/tinyexpr)
 add_subdirectory(lib/tinyexpr EXCLUDE_FROM_ALL)
 
 include_directories(lib)
-include_directories(lib/kseq)
 include_directories(lib/simd)
 include_directories(lib/gzstream)
 include_directories(lib/alp)
@@ -88,6 +94,6 @@
 add_subdirectory(lib/ksw2)
 add_subdirectory(data)
 add_subdirectory(src)
-if (NOT FRAMEWORK_ONLY)
+if (NOT FRAMEWORK_ONLY AND INSTALL_UTIL)
     add_subdirectory(util)
 endif ()

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -26,8 +26,8 @@
         nucleotide.out
         blosum62.out
         PAM30.out
-        CovSeqidQscPercMinDiag.out
-        CovSeqidQscPercMinDiagTargetCov.out
+        CovSeqidQscPercMinDiag.lib
+        CovSeqidQscPercMinDiagTargetCov.lib
         ExpOpt3_8_polished.cs32.lib
         Library255_may17.lib
         libPure_blosum62_255.lib

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -2,10 +2,11 @@
 set(HAVE_AVX2 0 CACHE BOOL "Have AVX2")
 set(HAVE_SSE4_1 0 CACHE BOOL "Have SSE4.1")
 set(HAVE_NEON 0 CACHE BOOL "Have NEON")
-set(HAVE_TESTS 1 CACHE BOOL "Have Tests")
+set(HAVE_TESTS 0 CACHE BOOL "Have Tests")
 set(HAVE_SHELLCHECK 1 CACHE BOOL "Have ShellCheck")
 set(HAVE_GPROF 0 CACHE BOOL "Have GPROF Profiler")
 set(ENABLE_WERROR 0 CACHE BOOL "Enable Warnings as Errors")
+set(REQUIRE_OPENMP 1 CACHE BOOL "Require availability of OpenMP")
 
 include(AppendTargetProperty)
 
@@ -38,7 +39,10 @@
         ${linclust_source_files}
         ${util_header_files}
         ${util_source_files}
-        ${workflow_source_files})
+        ${workflow_source_files}
+        CommandDeclarations.h
+        MMseqsBase.cpp
+        )
 
 target_include_directories(mmseqs-framework PUBLIC ${CMAKE_BINARY_DIR}/generated)
 target_include_directories(mmseqs-framework PUBLIC ${PROJECT_BINARY_DIR}/generated)
@@ -67,7 +71,7 @@
 append_target_property(mmseqs-framework COMPILE_FLAGS ${MMSEQS_CXX_FLAGS} -fno-exceptions -pedantic -Wall -Wextra -Wdisabled-optimization)
 append_target_property(mmseqs-framework LINK_FLAGS ${MMSEQS_CXX_FLAGS} -fno-exceptions -pedantic -Wall -Wextra -Wdisabled-optimization)
 
-if (${ENABLE_WERROR})
+if (ENABLE_WERROR)
     append_target_property(mmseqs-framework COMPILE_FLAGS -Werror)
     append_target_property(mmseqs-framework LINK_FLAGS -Werror)
 endif()
@@ -113,32 +117,32 @@
     target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_POSIX_MADVISE=1)
 endif ()
 
-#SSE
-if (${HAVE_AVX2})
+# SIMD instruction sets support
+if (HAVE_AVX2)
     target_compile_definitions(mmseqs-framework PUBLIC -DAVX2=1)
     append_target_property(mmseqs-framework COMPILE_FLAGS -mavx2 -Wa,-q)
     append_target_property(mmseqs-framework LINK_FLAGS -mavx2 -Wa,-q)
-elseif (${HAVE_SSE4_1})
+elseif (HAVE_SSE4_1)
     target_compile_definitions(mmseqs-framework PUBLIC -DSSE=1)
     append_target_property(mmseqs-framework COMPILE_FLAGS -msse4.1)
     append_target_property(mmseqs-framework LINK_FLAGS -msse4.1)
-elseif (${HAVE_NEON})
+elseif (HAVE_NEON)
     target_compile_definitions(mmseqs-framework PUBLIC -DSSE=1 -DNEON=1)
 else ()
     include(CheckSSEFeatures)
     append_target_property(mmseqs-framework COMPILE_FLAGS ${SSE_FLAGS})
     append_target_property(mmseqs-framework LINK_FLAGS ${SSE_FLAGS})
-    if (${HAVE_AVX2_EXTENSIONS})
+    if (HAVE_AVX2_EXTENSIONS)
         target_compile_definitions(mmseqs-framework PUBLIC -DAVX2=1)
         # debugging
         #   list(APPEND MMSEQS_DEFINITIONS -DSSE=1)
     else ()
-        if (${HAVE_SSE4_1_EXTENSIONS})
+        if (HAVE_SSE4_1_EXTENSIONS)
             target_compile_definitions(mmseqs-framework PUBLIC -DSSE=1)
         else ()
             message(FATAL_ERROR "At least SSE4.2 is needed to compile!")
-        endif (${HAVE_SSE4_1_EXTENSIONS})
-    endif (${HAVE_AVX2_EXTENSIONS})
+        endif (HAVE_SSE4_1_EXTENSIONS)
+    endif (HAVE_AVX2_EXTENSIONS)
 endif ()
 
 # tinyexpr
@@ -201,7 +205,7 @@
 endif ()
 
 # MPI
-if (${HAVE_MPI})
+if (HAVE_MPI)
     find_package(MPI REQUIRED)
     if (MPI_FOUND)
         message("-- Found MPI")
@@ -214,17 +218,22 @@
     endif ()
 endif ()
 
-# openmp integration
-find_package(OpenMP)
+
+find_package(OpenMP QUIET)
 if (OPENMP_FOUND)
     message("-- Found OpenMP")
     target_compile_definitions(mmseqs-framework PUBLIC -DOPENMP=1)
-    target_link_libraries(mmseqs-framework ${OpenMP_CXX_LIBRARIES})
+    # For GCC we dont want to do this since it breaks macOS static builds
+    # It will link libgomp.a internally (through -fopenmp I guess)
+    # and also link libgomp.dylib thus breaking static builds
+    # target_link_libraries(mmseqs-framework ${OpenMP_CXX_LIBRARIES})
     append_target_property(mmseqs-framework COMPILE_FLAGS ${OpenMP_CXX_FLAGS})
     append_target_property(mmseqs-framework LINK_FLAGS ${OpenMP_CXX_FLAGS})
-endif ()
-
-if (${HAVE_GPROF})
+elseif (REQUIRE_OPENMP)
+    message(FATAL_ERROR "-- Could not find OpenMP. Skip check with -DREQUIRE_OPENMP=0.")
+endif ()
+
+if (HAVE_GPROF)
     include(CheckCXXCompilerFlag)
     check_cxx_compiler_flag(-pg GPROF_FOUND)
     if (GPROF_FOUND)
@@ -238,10 +247,7 @@
 if (NOT FRAMEWORK_ONLY)
     include(MMseqsSetupDerivedTarget)
     add_subdirectory(version)
-    set(mmseqs_source_files
-            CommandDeclarations.h
-            mmseqs.cpp
-            )
+    set(mmseqs_source_files mmseqs.cpp)
 
     add_executable(mmseqs ${mmseqs_source_files})
     mmseqs_setup_derived_target(mmseqs)

=== lib/ksw2/CMakeLists.txt ===
add_library(ksw2 OBJECT
        ksw2.h
        ksw2_extz2_sse.cpp
        )
set_target_properties(ksw2 PROPERTIES COMPILE_FLAGS ${MMSEQS_CXX_FLAGS} LINK_FLAGS ${MMSEQS_CXX_FLAGS})

=== lib/tinyexpr/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4)

project(tinyexpr)

option(TE_POW_FROM_RIGHT "Evaluate exponents from right to left." OFF)
option(TE_NAT_LOG "Define the log function as natural logarithm." OFF)
option(build_tinyexpr_test "Build TinyExpr tests." OFF)
option(build_tinyexpr_test_pr "Build TinyExpr tests PR." OFF)
option(build_tinyexpr_bench "Build TinyExpr benchmark." OFF)
option(build_tinyexpr_example "Build TinyExpr example." OFF)
option(build_tinyexpr_example2 "Build TinyExpr example 2." OFF)
option(build_tinyexpr_example3 "Build TinyExpr example 3." OFF)

find_library(MATH_LIB m)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ansi -Wall -Wshadow -fPIC -O3")

set(SOURCE_FILES
        tinyexpr.c
        tinyexpr.h
        )

add_library(tinyexpr STATIC ${SOURCE_FILES})
if (TE_POW_FROM_RIGHT)
    target_compile_definitions(tinyexpr PRIVATE TE_POW_FROM_RIGHT)
endif()
if (TE_NAT_LOG)
    target_compile_definitions(tinyexpr PRIVATE TE_NAT_LOG)
endif()
target_link_libraries(tinyexpr ${MATH_LIB})
install(TARGETS tinyexpr ARCHIVE DESTINATION lib)
install(FILES tinyexpr.h DESTINATION include COMPONENT Devel)

if (build_tinyexpr_test)
    add_executable(tinyexpr_test test.c tinyexpr.c)
    target_link_libraries(tinyexpr_test ${MATH_LIB})
endif()

if (build_tinyexpr_test_pr)
    add_executable(tinyexpr_test_pr test.c tinyexpr.c)
    target_compile_definitions(tinyexpr_test_pr PRIVATE TE_POW_FROM_RIGHT TE_NAT_LOG)
    target_link_libraries(tinyexpr_test_pr ${MATH_LIB})
endif()

if (build_tinyexpr_bench)
    add_executable(tinyexpr_benchmark benchmark.c tinyexpr.c)
    target_link_libraries(tinyexpr_benchmark ${MATH_LIB})
endif()

if (build_tinyexpr_example)
    add_executable(tinyexpr_example example.c tinyexpr.c)
    target_link_libraries(tinyexpr_example ${MATH_LIB})
endif()

if (build_tinyexpr_example2)
    add_executable(tinyexpr_example2 example2.c tinyexpr.c)
    target_link_libraries(tinyexpr_example2 ${MATH_LIB})
endif()

if (build_tinyexpr_example3)
    add_executable(tinyexpr_example3 example3.c tinyexpr.c)
    target_link_libraries(tinyexpr_example3 ${MATH_LIB})
endif()

=== src/commons/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
         commons/A3MReader.h
         commons/AminoAcidLookupTables.h
         commons/BacktraceTranslator.h
+        commons/ByteParser.h
         commons/Command.h
         commons/CommandCaller.h
         commons/Concat.h
@@ -16,6 +17,8 @@
         commons/HeaderSummarizer.h
         commons/IndexReader.h
         commons/itoa.h
+        commons/KSeqBufferReader.h
+        commons/KSeqWrapper.h
         commons/MathUtil.h
         commons/MemoryMapped.h
         commons/MMseqsMPI.h
@@ -26,6 +29,7 @@
         commons/Parameters.h
         commons/PatternCompiler.h
         commons/ScoreMatrix.h
+        commons/ScoreMatrixFile.h
         commons/Sequence.h
         commons/SubstitutionMatrix.h
         commons/SubstitutionMatrixProfileStates.h
@@ -58,6 +62,7 @@
         commons/Parameters.cpp
         commons/ProfileStates.cpp
         commons/LibraryReader.cpp
+        commons/ScoreMatrixFile.cpp
         commons/Sequence.cpp
         commons/SubstitutionMatrix.cpp
         commons/tantan.cpp

=== src/multihit/CMakeLists.txt ===
set(multihit_header_files
        multihit/Aggregation.h
        PARENT_SCOPE
        )


set(multihit_source_files
        multihit/besthitperset.cpp
        multihit/combinepvalperset.cpp
        multihit/resultsbyset.cpp
        multihit/Aggregation.h
        multihit/Aggregation.cpp
        multihit/MultiHitDb.cpp
        multihit/MultiHitSearch.cpp
        multihit/SummarizeResultsBySet.cpp
        PARENT_SCOPE
        )

=== src/taxonomy/CMakeLists.txt ===
--- 
+++ 
@@ -11,5 +11,6 @@
         taxonomy/filtertaxdb.cpp
         taxonomy/createtaxdb.cpp
         taxonomy/taxonomyreport.cpp
+        taxonomy/TaxonomyExpression.h
         PARENT_SCOPE
         )

=== src/util/CMakeLists.txt ===
--- 
+++ 
@@ -47,7 +47,6 @@
         util/result2stats.cpp
         util/reverseseq.cpp
         util/rmdb.cpp
-        util/shellcompletion.cpp
         util/extractframes.cpp
         util/sortresult.cpp
         util/splitdb.cpp

## mmseqs2 10-6d92c+ds

=== debian/changelog ===
mmseqs2 (10-6d92c+ds-2) unstable; urgency=medium

  * Team upload.
  * Do not misuse d/changelog as another README.source -> thus moved
    TODO item from d/changelog to README.source
  * Standards-Version: 4.5.0 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Do not try to call tests that are removed upstream
    Closes: #951165

 -- Andreas Tille <tille@debian.org>  Tue, 11 Feb 2020 22:57:58 +0100

mmseqs2 (10-6d92c+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper-compat 12 (routine-update)
  * Standards-Version: 4.4.1 (routine-update)

 -- Steffen Moeller <moeller@debian.org>  Sun, 19 Jan 2020 14:16:12 +0100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Uploaders: Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                libgzstream-dev,
                libzstd-dev,
                zlib1g-dev,
                libbz2-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/mmseqs2
 Vcs-Git: https://salsa.debian.org/med-team/mmseqs2.git
 Homepage: https://github.com/soedinglab/MMseqs2

=== debian/rules ===
--- 
+++ 
@@ -15,10 +15,10 @@
 override_dh_install:
 	dh_install
 	mkdir -p debian/mmseqs2/usr/lib/mmseqs2/test
-	cp src/test/*.index debian/mmseqs2/usr/lib/mmseqs2/test
-	cp src/test/dataGap debian/mmseqs2/usr/lib/mmseqs2/test
-	cp src/test/dataLinear debian/mmseqs2/usr/lib/mmseqs2/test
-	cp -r obj-$(DEB_HOST_MULTIARCH)/src/test debian/mmseqs2/usr/lib/mmseqs2
+	cp src/test/*.index debian/mmseqs2/usr/lib/mmseqs2/test/
+	cp src/test/dataGap debian/mmseqs2/usr/lib/mmseqs2/test/
+	cp src/test/dataLinear debian/mmseqs2/usr/lib/mmseqs2/test/
+	#cp -r obj-$(DEB_HOST_MULTIARCH)/src/test debian/mmseqs2/usr/lib/mmseqs2/
 
 	# We also remove unneeded files & folders like CMake
 	rm -r debian/mmseqs2/usr/lib/mmseqs2/test/CMakeFiles \

## mmseqs2 11

=== CMakeLists.txt ===
--- 
+++ 
@@ -83,12 +83,23 @@
 include_directories(lib/tinyexpr)
 add_subdirectory(lib/tinyexpr EXCLUDE_FROM_ALL)
 
+# microtar
+include_directories(lib/microtar)
+add_subdirectory(lib/microtar)
+
+# default cygwin allocator (dlmalloc) locks on every allocation and destroys MT performance
+if (CYGWIN)
+    add_subdirectory(lib/nedmalloc)
+endif()
+
 include_directories(lib)
 include_directories(lib/simd)
 include_directories(lib/gzstream)
 include_directories(lib/alp)
 include_directories(lib/cacode)
 include_directories(lib/ksw2)
+include_directories(lib/xxhash)
+
 add_subdirectory(lib/cacode)
 add_subdirectory(lib/alp)
 add_subdirectory(lib/ksw2)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -120,8 +120,13 @@
 # SIMD instruction sets support
 if (HAVE_AVX2)
     target_compile_definitions(mmseqs-framework PUBLIC -DAVX2=1)
-    append_target_property(mmseqs-framework COMPILE_FLAGS -mavx2 -Wa,-q)
-    append_target_property(mmseqs-framework LINK_FLAGS -mavx2 -Wa,-q)
+    if (CMAKE_COMPILER_IS_CLANG)
+        append_target_property(mmseqs-framework COMPILE_FLAGS -mavx2)
+        append_target_property(mmseqs-framework LINK_FLAGS -mavx2)
+    else ()
+        append_target_property(mmseqs-framework COMPILE_FLAGS -mavx2 -Wa,-q)
+        append_target_property(mmseqs-framework LINK_FLAGS -mavx2 -Wa,-q)
+    endif ()
 elseif (HAVE_SSE4_1)
     target_compile_definitions(mmseqs-framework PUBLIC -DSSE=1)
     append_target_property(mmseqs-framework COMPILE_FLAGS -msse4.1)
@@ -145,8 +150,10 @@
     endif (HAVE_AVX2_EXTENSIONS)
 endif ()
 
-# tinyexpr
-target_link_libraries(mmseqs-framework tinyexpr)
+target_link_libraries(mmseqs-framework tinyexpr libzstd_static microtar)
+if (CYGWIN)
+    target_link_libraries(mmseqs-framework nedmalloc)
+endif ()
 
 find_package(ZLIB QUIET)
 if (ZLIB_FOUND)
@@ -226,7 +233,9 @@
     # For GCC we dont want to do this since it breaks macOS static builds
     # It will link libgomp.a internally (through -fopenmp I guess)
     # and also link libgomp.dylib thus breaking static builds
-    # target_link_libraries(mmseqs-framework ${OpenMP_CXX_LIBRARIES})
+    if (NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
+        target_link_libraries(mmseqs-framework ${OpenMP_CXX_LIBRARIES})
+    endif()
     append_target_property(mmseqs-framework COMPILE_FLAGS ${OpenMP_CXX_FLAGS})
     append_target_property(mmseqs-framework LINK_FLAGS ${OpenMP_CXX_FLAGS})
 elseif (REQUIRE_OPENMP)

=== data/resources/CMakeLists.txt ===
set(GENERATED_RESOURCES
        resources/CovSeqidQscPercMinDiag.lib
        resources/CovSeqidQscPercMinDiagTargetCov.lib
        resources/ExpOpt3_8_polished.cs32.lib
        resources/Library255_may17.lib
        resources/libPolished_8.lib
        resources/cs219.lib
        resources/krona_prelude.html

        PARENT_SCOPE
        )

=== data/workflow/CMakeLists.txt ===
set(GENERATED_WORKFLOWS
        workflow/easysearch.sh
        workflow/easycluster.sh
        workflow/easytaxonomy.sh
        workflow/blastp.sh
        workflow/blastpgp.sh
        workflow/map.sh
        workflow/rbh.sh
        workflow/linclust.sh
        workflow/clustering.sh
        workflow/cascaded_clustering.sh
        workflow/update_clustering.sh
        workflow/searchtargetprofile.sh
        workflow/createindex.sh
        workflow/createtaxdb.sh
        workflow/translated_search.sh
        workflow/taxonomy.sh
        workflow/multihitdb.sh
        workflow/multihitsearch.sh
        workflow/enrich.sh
        workflow/blastn.sh
        workflow/searchslicedtargetprofile.sh
        workflow/linsearch.sh
        workflow/databases.sh

        PARENT_SCOPE
        )

=== src/util/CMakeLists.txt ===
--- 
+++ 
@@ -38,6 +38,7 @@
         util/prefixid.cpp
         util/profile2cs.cpp
         util/profile2pssm.cpp
+        util/profile2seq.cpp
         util/result2flat.cpp
         util/result2msa.cpp
         util/result2rbh.cpp
@@ -61,6 +62,7 @@
         util/translatenucs.cpp
         util/translateaa.cpp
         util/tsv2db.cpp
+        util/tar2db.cpp
         util/proteinaln2nucl.cpp
         util/versionstring.cpp
         util/diskspaceavail.cpp

=== src/workflow/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 set(workflow_source_files
         workflow/Cluster.cpp
         workflow/ClusterUpdate.cpp
+        workflow/Databases.cpp
         workflow/Linclust.cpp
         workflow/EasySearch.cpp
         workflow/EasyCluster.cpp
